<?php
namespace Teknisa\PLA\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Pla00500ConsumoServicoReport extends \Zeedhi\Framework\Controller\Report {
  
  protected $birtStrategy;
	protected $dataSourceManager;
	protected $environment;
	protected $entityManager;
	protected $service;
	protected $connection;
	protected $util;

	public function __construct($reportService, $birtStrategy, $dataSourceManager, $environment, $entityManager, $util, $libUtilities, $connection){
		    $this->reportService              = $reportService;
		    $this->birtStrategy               = $birtStrategy;
        $this->dataSourceManager    			= $dataSourceManager;
        $this->environment          			= $environment;
        $this->entityManager        			= $entityManager;
        $this->util                 			= $util;
        $this->libUtilities         			= $libUtilities;
        $this->connection						      = $connection;
	}
    
  protected $reportMapping = array (
  	'PLA00500' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'NRORG' => 'P_NRORG',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'DTINIVALID' => 'P_DTINIVALID',
          'IDTIPOCONS' => 'P_IDTIPOCONS',
          'CONSUMO' => 'P_CONSUMO'
  	    )
	  ),
  	'PLA00501' =>
      array (
        'strategy' => 'BIRT',
        'parameterMapping' =>
        array (
          'NRORG' => 'P_NRORG',
          'CDFILIAL' => 'P_CDFILIAL',
          'CDSERVFILI' => 'P_CDSERVFILI',
          'CONSUMO' => 'P_CONSUMO',
          'DTINI' => 'P_DTINI',
          'DTFIN' => 'P_DTFIN'
  	    )
	  )	  
  );   
	
	
	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
	  $row = $request->getRow();
	  
	  $row['NRORG'] = $this->environment->getNrOrg();
	  
	  $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
	}
    
}